/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#define PY_SSIZE_T_CLEAN
#include <Python.h>




#if PY_VERSION_HEX < 0x02050000
typedef int Py_ssize_t;
#define PY_SSIZE_T_MAX INT_MAX
#define PY_SSIZE_T_MIN INT_MIN
typedef inquiry lenfunc;
typedef intargfunc ssizeargfunc;
typedef intobjargproc ssizeobjargproc;
#endif


#line 3 "./awn_extras.override"
/*
 * Copyright (c) 2008 Mark Lee <avant-wn@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
*/
#include <pycairo.h>
#include <pygobject.h>
#include <libawn/awn-cairo-utils.h>
#include <gdk/gdkcolor.h>
#include <gtk/gtk.h>
#include <libawn-extras/awn-extras.h>

static Pycairo_CAPI_t *Pycairo_CAPI;
#line 47 "awn_extras.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGdkColor_Type;
#define PyGdkColor_Type (*_PyGdkColor_Type)
static PyTypeObject *_PyGdkPixbuf_Type;
#define PyGdkPixbuf_Type (*_PyGdkPixbuf_Type)
static PyTypeObject *_PyCairoSurface_Type;
#define PyCairoSurface_Type (*_PyCairoSurface_Type)
static PyTypeObject *_PyGtkImageMenuItem_Type;
#define PyGtkImageMenuItem_Type (*_PyGtkImageMenuItem_Type)


/* ---------- forward type declarations ---------- */

#line 63 "awn_extras.c"



/* ----------- functions ----------- */

#line 38 "./awn_extras.override"
static PyObject *
_wrap_get_pixbuf_from_surface (PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "surface", "pixbuf", NULL };

    PyObject *py_surface;
    PyObject *py_pixbuf = NULL;
    GdkPixbuf *pixbuf;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O|O:Surface.to_pixbuf", kwlist, &py_surface, &py_pixbuf)) {
        return NULL;
    }

    if (!PyObject_TypeCheck (py_surface, &PyCairoSurface_Type)) {
        PyErr_SetString (PyExc_TypeError, "Argument must be a cairo surface");
        return NULL;
    }

    if (py_pixbuf) {
        if (!pygobject_check (py_pixbuf, &PyGdkPixbuf_Type)) {
            PyErr_SetString (PyExc_TypeError, "Second argument (if set) must be a GdkPixbuf");
            return NULL;
        }
        pixbuf = surface_2_pixbuf (GDK_PIXBUF (pygobject_get (py_pixbuf)), ((PycairoSurface*)py_surface)->surface);
    } else {
        pixbuf = get_pixbuf_from_surface (((PycairoSurface*)py_surface)->surface);
    }
    return pygobject_new (G_OBJECT (pixbuf));
}
#line 99 "awn_extras.c"


#line 69 "./awn_extras.override"
static PyObject *
_wrap_awncolor_to_string (PyObject *self, PyObject *args, PyObject *kwargs)
{
#define COLOR_DICT_ERR PyErr_SetString (PyExc_TypeError, dict_err); return NULL

    static char *kwlist[] = { "color", NULL };

    PyObject *py_color;
    AwnColor *color = g_malloc (sizeof (AwnColor));
    PyObject *result;
    char *dict_err = "Argument must be an RGBA color dictionary";

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O:dict_to_rgba_string", kwlist, &py_color)) {
        return NULL;
    }

    if (!PyDict_Check (py_color)) {
        COLOR_DICT_ERR;
    }

    if (!PyDict_Contains (py_color, PyString_FromString("red"))) {
        COLOR_DICT_ERR;
    }
    color->red = PyFloat_AsDouble (PyDict_GetItemString (py_color, "red"));

    if (!PyDict_Contains (py_color, PyString_FromString("green"))) {
        COLOR_DICT_ERR;
    }
    color->green = PyFloat_AsDouble (PyDict_GetItemString (py_color, "green"));

    if (!PyDict_Contains (py_color, PyString_FromString("blue"))) {
        COLOR_DICT_ERR;
    }
    color->blue = PyFloat_AsDouble (PyDict_GetItemString (py_color, "blue"));

    if (!PyDict_Contains (py_color, PyString_FromString("alpha"))) {
        COLOR_DICT_ERR;
    }
    color->alpha = PyFloat_AsDouble (PyDict_GetItemString (py_color, "alpha"));

    result = PyString_FromString (awncolor_to_string (color));
    g_free (color);

    return result;
}
#line 148 "awn_extras.c"


#line 116 "./awn_extras.override"
static PyObject *
_wrap_gdkcolor_to_awncolor (PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", "alpha", NULL };

    PyObject *py_color;
    GdkColor *gcolor;
    double *alpha = NULL;
    AwnColor color;
    PyObject *color_dict;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "O|d:Color.to_dict", kwlist, &py_color, alpha)) {
        return NULL;
    }

    if (!PyObject_TypeCheck (py_color, &PyGdkColor_Type)) {
        PyErr_SetString (PyExc_TypeError, "First argument must be a gdk.Color");
        return NULL;
    }

    gcolor = (GdkColor*)pygobject_get (py_color);

    if (alpha) {
        color = gdkcolor_to_awncolor_with_alpha (gcolor, *alpha);
    } else {
        color = gdkcolor_to_awncolor (gcolor);
    }

    color_dict = PyDict_New ();
    PyDict_SetItemString (color_dict, "red", PyFloat_FromDouble (color.red));
    PyDict_SetItemString (color_dict, "green", PyFloat_FromDouble (color.green));
    PyDict_SetItemString (color_dict, "blue", PyFloat_FromDouble (color.blue));
    PyDict_SetItemString (color_dict, "alpha", PyFloat_FromDouble (color.alpha));

    return color_dict;
}
#line 188 "awn_extras.c"


#line 154 "./awn_extras.override"
static PyObject *
_wrap_notify_message (PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "summary", "body", "icon", "timeout", "async", NULL };

    gchar *summary;
    gchar *body;
    gchar *icon;
    glong timeout;
    gboolean async;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs, "ssslb:notify_message", kwlist, &summary, &body, &icon, &timeout, &async)) {
        return NULL;
    }

    if (async) {
        notify_message_async (summary, body, icon, timeout);
        Py_INCREF(Py_None);
        return Py_None;
    } else {
        return PyBool_FromLong (notify_message (summary, body, icon, timeout));
    }
}
#line 215 "awn_extras.c"


static PyObject *
_wrap_notify_message_extended(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "summary", "body", "icon_str", "urgency", "timeout", NULL };
    char *summary, *body, *icon_str;
    int urgency;
    glong timeout;
    GError *perror = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"sssil:notify_message_extended", kwlist, &summary, &body, &icon_str, &urgency, &timeout))
        return NULL;
    
    notify_message_extended(summary, body, icon_str, urgency, timeout, &perror);
    
    if (pyg_error_check(&perror))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

#line 179 "./awn_extras.override"
static PyObject*
_wrap_gtk_image_menu_item_new_with_label (PyObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "label", NULL };

  gchar *label;
  GtkWidget *item;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "s:image_menu_item_new_with_label", kwlist, &label))
  {
    return NULL;
  }

  item = gtk_image_menu_item_new_with_label (label);

  if (item)
  {
    return pygobject_new ((GObject*)item);
  }
  else
  {
    return NULL;
  }
}
#line 263 "awn_extras.c"


const PyMethodDef pyawn_extras_functions[] = {
    { "surface_to_pixbuf", (PyCFunction)_wrap_get_pixbuf_from_surface, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "dict_to_rgba_string", (PyCFunction)_wrap_awncolor_to_string, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "gdkcolor_to_dict", (PyCFunction)_wrap_gdkcolor_to_awncolor, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "notify_message", (PyCFunction)_wrap_notify_message, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "notify_message_extended", (PyCFunction)_wrap_notify_message_extended, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "image_menu_item_new_with_label", (PyCFunction)_wrap_gtk_image_menu_item_new_with_label, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pyawn_extras_add_constants(PyObject *module, const gchar *strip_prefix)
{
#ifdef VERSION
    PyModule_AddStringConstant(module, "__version__", VERSION);
#endif
    PyModule_AddIntConstant(module, (char *) pyg_constant_strip_prefix("NOTIFY_URGENCY_LOW", strip_prefix), NOTIFY_URGENCY_LOW);
    PyModule_AddIntConstant(module, (char *) pyg_constant_strip_prefix("NOTIFY_URGENCY_NORMAL", strip_prefix), NOTIFY_URGENCY_NORMAL);
    PyModule_AddIntConstant(module, (char *) pyg_constant_strip_prefix("NOTIFY_URGENCY_CRITICAL", strip_prefix), NOTIFY_URGENCY_CRITICAL);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pyawn_extras_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("cairo")) != NULL) {
        _PyCairoSurface_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Surface");
        if (_PyCairoSurface_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Surface from cairo");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import cairo");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        _PyGtkImageMenuItem_Type = (PyTypeObject *)PyObject_GetAttrString(module, "ImageMenuItem");
        if (_PyGtkImageMenuItem_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name ImageMenuItem from gtk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk");
        return ;
    }
    if ((module = PyImport_ImportModule("gtk.gdk")) != NULL) {
        _PyGdkColor_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Color");
        if (_PyGdkColor_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Color from gtk.gdk");
            return ;
        }
        _PyGdkPixbuf_Type = (PyTypeObject *)PyObject_GetAttrString(module, "Pixbuf");
        if (_PyGdkPixbuf_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Pixbuf from gtk.gdk");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gtk.gdk");
        return ;
    }


#line 349 "awn_extras.c"
}
